



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Vue2.0学习——axios用法详解</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Vue2.0学习——axios用法详解</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-01 09:51:28 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h4>功能特性</h4>
<ul><li>在浏览器中发送 XMLHttpRequests 请求</li>
<li>在 node.js 中发送 http请求</li>
<li>支持 Promise API</li>
<li>拦截请求和响应</li>
<li>转换请求和响应数据</li>
<li>自动转换 JSON 数据</li>
<li>客户端支持保护安全免受 XSRF 攻击</li></ul>
<h4>使用</h4>
<div>
<pre class="prettyprint linenums">npm install axios --save-dev</pre>
</div>
<div>
<pre class="prettyprint linenums">import axios from 'axios'</pre>
</div>
<p>这时候如果在其它的组件中，是无法使用 axios 命令的。</p>
<div>
<pre class="prettyprint linenums">Vue.use(axios)          // 注意 这样的用法是有问题的，axios不支持Vue.use()的声明方式</pre>
</div>
<p>但如果将 axios 改写为 Vue 的原型属性，就能解决这个问题</p>
<div>
<pre class="prettyprint linenums">Vue.prototype.$axios= axios</pre>
</div>
<p>在 main.js 中添加了这两行代码之后，就能直接在组件的 methods 中使用 $axios命令</p>
<div>
<pre class="prettyprint linenums">methods: {<br />
  getData() {<br />
    this.axios({<br />
      method: 'get',<br />
      url: 'data/personData.json'<br />
    })<br />
    .then(function (response) {<br />
      console.log(response)<br />
    })<br />
    .catch(function (error) {<br />
      console.log(error)<br />
    })<br />
  }<br />
}</pre>
</div>
<p>这是axios的回调函数，.then为请求成功的回调函数，而.catch为请求失败的回调函数。</p>
<p>这两个回调函数都有各自独立的作用域，如果直接在里面访问 this，无法访问到 Vue 实例，怎么办？</p>
<p>只要添加一个 .bind(this) 就能解决这个问题</p>
<div>
<pre class="prettyprint linenums">then(function(res){<br />
 console.log(this.data)<br />
}.bind(this))</pre>
</div>
<p><strong>一些坑</strong><br /><strong>1.vue cli脚手架前端调后端数据接口时候的本地代理跨域。</strong><br />如我在本地localhost访问接口http://40.00.100.100:3002/是要跨域的，相当于浏览器设置了一到门槛，会报错XMLHTTPRequest can not load http://40.00.100.100:3002/. Response to preflight request doesn&rsquo;t pass access control&hellip;.&nbsp;在webpack配置一下proxyTable就OK了，如下&nbsp;<br />config/index.js</p>
<div>
<pre class="prettyprint linenums">dev: {<br />
    //加入以下<br />
    proxyTable: {<br />
      '/api': {<br />
        target: 'http://40.00.100.100:3002/',//设置你调用的接口域名和端口号 别忘了加http<br />
        changeOrigin: true,<br />
        pathRewrite: {<br />
          '^/api': '/'//这里理解成用&lsquo;/api&rsquo;代替target里面的地址，后面组件中我们掉接口时直接用api代替 比如我要调用'http://40.00.100.100:3002/user/add'，直接写&lsquo;/api/user/add&rsquo;即可<br />
        }<br />
      }<br />
    },</pre>
</div>
<p>试一下，跨域成功了，但是注意了，这只是开发环境（dev）中解决了跨域问题，生产环境中真正部署到服务器上如果是非同源还是存在跨域问题，如我们部署的服务器端口是3001，需要前后端联调，第一步前端我们可以分生产production和开发development两种环境分别测试，在config/dev.env.js和prod.env.js里也就是开发/生产环境下分别配置一下请求的地址API_HOST，开发环境中我们用上面配置的代理地址api，生产环境下用正常的接口地址，所以这样配置</p>
<div>
<pre class="prettyprint linenums">module.exports = merge(prodEnv, {<br />
  NODE_ENV: '"development"',//开发环境<br />
  API_HOST:"/api/"<br />
})</pre>
</div>
<div>
<pre class="prettyprint linenums">module.exports = {<br />
  NODE_ENV: '"production"',//生产环境<br />
  API_HOST:'"http://40.00.100.100:3002/"'<br />
}</pre>
</div>
<p>当然不管是开发还是生产环境都可以直接请求http://40.00.100.100:3002/。配置好之后测试时程序会自动判断当前是开发还是生产环境，然后自动匹配API_HOST，我们在任何组件里都能用process.env.API_HOST来使用地址如</p>
<div>
<pre class="prettyprint linenums">instance.post(process.env.API_HOST+'user/login', this.form)</pre>
</div>
<p>然后第二步后端服务器配置一下cros跨域即可，就是access-control-allow-origin：*&nbsp;允许所有访问的意思。</p>
<p>综上：开发的环境下我们前端可以自己配置个proxy代理就能跨域了，真正的生产环境下还需要后端的配合的。某大神说：此方法ie9及以下不好使，如果需要兼容，最好的办法是后端在服务器端口加个代理，效果类似开发时webpack的代理。</p>
<p><strong>2.axios发送get post请求问题&nbsp;</strong><br />发送post请求时一般都要设置Content-Type，发送内容的类型，application/json指发送json对象但是要提前stringify一下。application/xxxx-form指发送？a=b&amp;c=d格式，可以用qs的方法格式化一下，qs在安装axios后会自动安装，只需要组件里import一下即可</p>
<div>
<pre class="prettyprint linenums">const postData=JSON.stringify(this.formCustomer);<br />
'Content-Type':'application/json'}

const postData=Qs.stringify(this.formCustomer);//过滤成？&amp;=格式<br />
'Content-Type':'application/xxxx-form'}</pre>
</div>
<p><strong>3.axios拦截器的使用&nbsp;</strong></p>
<p>当我们访问某个地址页面时，有时会要求我们重新登录后再访问该页面，也就是身份认证失效了，如token丢失了，或者是token依然存在本地，但是却失效了，所以单单判断本地有没有token值不能解决问题。此时请求时服务器返回的是401错误，授权出错，也就是没有权利访问该页面。&nbsp;<br />我们可以在发送所有请求之前和操作服务器响应数据之前对这种情况过滤。</p>
<div>
<pre class="prettyprint linenums">// http request 请求拦截器，有token值则配置上token值<br />
axios.interceptors.request.use(<br />
    config =&gt; {<br />
        if (token) {  // 每次发送请求之前判断是否存在token，如果存在，则统一在http请求的header都加上token，不用每次请求都手动添加了<br />
            config.headers.Authorization = token;<br />
        }<br />
        return config;<br />
    },<br />
    err =&gt; {<br />
        return Promise.reject(err);<br />
    });

// http response 服务器响应拦截器，这里拦截401错误，并重新跳入登页重新获取token<br />
axios.interceptors.response.use(<br />
    response =&gt; {<br />
        return response;<br />
    },<br />
    error =&gt; {<br />
        if (error.response) {<br />
            switch (error.response.status) {<br />
                case :<br />
                    // 这里写清除token的代码<br />
                    router.replace({<br />
                        path: 'login',<br />
                        query: {redirect: router.currentRoute.fullPath}//登录成功后跳入浏览的当前页面<br />
                    })<br />
            }<br />
        }<br />
        return Promise.reject(error.response.data)<br />
    });</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/wq1ky7z9.html">其原因可能是堆被损坏，这说明 100BloodCellSegTest&period;exe 中或它所加载的任何 DLL 中有 Bug。</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mr7429.html">搭建自己的ngrok服务&lpar;国内直接可用http&colon;&sol;&sol;qydev&period;com&sol;&num;&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvyerxq.html">linux mono环境</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8z5jo18.html">Xamarin迁移到 Unified API 注意事项</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okkzyx9.html">使用BroadcastReceiver监听系统接收的短信</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rd13vd8.html">netty是什么？</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdez4wx9.html">highcharts 结合phantomjs纯后台生成图片系列二之php</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rd12ve8.html">How to upgrade boost libary using apt-get &quest;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pj6dzd9.html">微信开发第6章 通过accesstoken获取用户粉丝列表</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxn1d1d8.html">树形控件CTreeCtrl的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjv0ez8.html">JavaEE&mdash;&mdash;Intellij Idea 创建JavaWeb项目</a>
		</li>
						<li><a href="https://www.batexi.com/a/90m2emj8.html">HSSFWorkbook和XSSFWorkbook的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdwzz579.html">java第二周的作业</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kj7ozj9.html">python中变量命名的基本规则，标识符和关键字</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxd7pwz9.html">&lbrack;C基础修炼&rsqb; &lbrack;C课程设计&rsqb;C语言课程设计之图书管理系统</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kopm17q.html">解决Illegal mix of collations &lpar;latin1&lowbar;swedish&lowbar;ci&comma;IMPLICIT&rpar; and &lpar;utf8&lowbar;general&lowbar;ci&comma;COER</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnnwe32q.html">POJ 2379</a>
		</li>
						<li><a href="https://www.batexi.com/a/93p2dvz8.html">为什么JSP会比Beetl慢</a>
		</li>
						<li><a href="https://www.batexi.com/a/93jyvrg8.html">zigbee广播通信原理</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zvod6n9.html">python3之循环</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qv202rj9.html">php OpenSSL 加解密</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv202py9.html">在Centos7 上安装SVN</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kj5jg79.html">Freemaker：操作集合</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gjdpvl9.html">单点登录SSO的原理及实现方式总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnv5npk8.html">django&period;db&period;utils&period;OperationalError&colon; &lpar;1045&comma; &amp;quot&semi;Access denied for user &amp;&num;39&semi;ODBC&amp;&num;39&semi;&commat;&amp;&num;39&semi;localhost&amp;&num;39&semi; &lpar;using password&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j1plg09.html">SpringCloud路由（网关）</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pwxg6d8.html">js获取url参数值，并解决中文乱码</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1rj4e48.html">利用Form组件和ajax实现的注册</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyyr6g2q.html">【python】多进程与mongo</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv20j4o9.html">PDF怎么编辑，如何旋转PDF页面方向</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
